
 /*--------------------------------------------------------------------------*/
 /*                 PRUDENS INC (c) 1996                                     */
 /*                 STREAMWOOD, ILLINOIS 60107  USA                          */
 /*                 ALL RIGHTS RESERVED.                                     */
 /*                 Class: SAMPLES                                           */
 /*--------------------------------------------------------------------------*/

 //
 //
 //   File :    DLG16.C
 //
 //   Purpose : This provides a sample for SMM95.
 //             This is the 16 bit side.
 //
 //


/*---------------------------------------------------------------------------*/
/*                    C/Windows/PM Related Header Files                      */
/*---------------------------------------------------------------------------*/
#include <windows.h>


/*---------------------------------------------------------------------------*/
/*                        Local Header Files                                 */
/*---------------------------------------------------------------------------*/
#include "common.h"


/*---------------------------------------------------------------------------*/
/*                        Predefined Constants                               */
/*---------------------------------------------------------------------------*/
#define MAX_HEAPSIZE    10240
#define MAX_STRLENGTH   1024


/*---------------------------------------------------------------------------*/
/*                        Local/Private Variables                            */
/*---------------------------------------------------------------------------*/
LPSTR       lpPtr16 = (LPSTR) 0;
HWND        hDlg32  = (HWND)  0;


/*---------------------------------------------------------------------------*/
/*                        Local/Private APIs                                 */
/*---------------------------------------------------------------------------*/
BOOL WINAPI DlgProc16 ( HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam );


/*---------------------------------------------------------------------------*/
/*                                                                           */
/* Class        : Samples                                                    */
/*                                                                           */
/* Method       : WinMain                                                    */
/*                                                                           */
/* Description  : stand Windows entry                                        */
/*                                                                           */
/* Misc.        :                                                            */
/*                                                                           */
/*---------------------------------------------------------------------------*/
int PASCAL WinMain ( HINSTANCE hCur, HINSTANCE hPrev, LPSTR lpCmd, int nCmd )
{
    FARPROC     pfnDlgProc;

    // Prevent from starting the second instance
    if ( !( hDlg32 = FindWindow ( NULL, DLG32_TITLE ) ) )
    {
       MessageBox ( 0, "Start DLG32 instead.", "INFORMATION",
                    MB_OK | MB_ICONEXCLAMATION );
       return 0;
    }
    if ( FindWindow ( NULL, DLG16_TITLE ) )
    {
       MessageBox ( 0, "Can not start more than one Dlg16", "INFORMATION",
                    MB_OK | MB_ICONEXCLAMATION );
       return 0;
    }

    pfnDlgProc = MakeProcInstance ( (FARPROC) DlgProc16, hCur );
    DialogBox ( hCur, "SMMDLG", HWND_DESKTOP, pfnDlgProc );
    FreeProcInstance ( pfnDlgProc );

    return 0L;
}


/*---------------------------------------------------------------------------*/
/*                                                                           */
/* Class        : Samples                                                    */
/*                                                                           */
/* Method       : DlgProc16                                                  */
/*                                                                           */
/* Description  : stand DlgProc                                              */
/*                                                                           */
/* Misc.        :                                                            */
/*                                                                           */
/*---------------------------------------------------------------------------*/
BOOL WINAPI DlgProc16 ( HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam )
{
    switch ( uMsg )
    {
       case WM_INITDIALOG:
            SetWindowText ( hDlg, DLG16_TITLE );
            ShowWindow ( GetDlgItem ( hDlg, IDCANCEL ), SW_HIDE );

            {
               RECT     rect;

               GetWindowRect ( hDlg, &rect );
               SetWindowPos ( hDlg, hDlg32, rect.left, rect.top + rect.bottom, 0, 0, SWP_NOSIZE );
            }
            return TRUE;

       case WM_COMMAND:
            switch ( LOWORD (wParam) )
            {
               case IDCANCEL:
                    EndDialog ( hDlg, 0 );
                    break;

               case IDC_SELECTOR:
                    lpPtr16 = MAKELP ( LOWORD ( lParam ), 0 );
                    break;

               case IDC_OFFSET:
                    lpPtr16 = (LPSTR) ( (LONG) lpPtr16 | LOWORD ( lParam ) );
                    break;

               case IDC_REFRESH:
                    if ( lpPtr16 )
                       SetDlgItemText ( hDlg, IDC_EDITBOX, lpPtr16 );
                    break;

               case IDC_EDITBOX:
                    switch ( HIWORD (lParam) )
                    {
                       case EN_CHANGE:
                            if ( lpPtr16 )
                            {
                               GetWindowText ( (HWND) lParam, lpPtr16, MAX_STRLENGTH );

                               if ( GetFocus () == (HWND) LOWORD (lParam) )
                                  SendMessage ( hDlg32, WM_COMMAND, IDC_REFRESH, 0L );
                            }
                            break;
                    }
                    break;
            }

            return TRUE;
    }

    return FALSE;
}


