unit Mem16_0;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Buttons;

const
  WM_SENDSELECTOROFFSET = WM_USER + 101;
  WM_RECEIVEMSG         = WM_USER + 102;

type
  TMainForm = class(TForm)
    SelectorOffsetLabel: TLabel;
    FromMem32Label: TLabel;
    FromMem32Edit: TEdit;
    ToMem32Label: TLabel;
    ToMem32Edit: TEdit;
    SendButton: TButton;
    CloseBitBtn: TBitBtn;
    procedure FormCreate(Sender: TObject);
    procedure CloseBitBtnClick(Sender: TObject);
    procedure SendButtonClick(Sender: TObject);
  private
    SelectorW, OffsetW: Word;
  public
    procedure MessageWM_SENDSELECTOROFFSET (var Message: TMsg); message WM_SENDSELECTOROFFSET;
  end;

var
  MainForm: TMainForm;

implementation

{$R *.DFM}

procedure
  TMainForm.FormCreate
    (Sender: TObject);
begin
  SelectorW := 0;
  OffsetW := 0;
end; {TForm1.FormCreate}

procedure
  TMainForm.CloseBitBtnClick
    (Sender: TObject);
begin
  Close;
end; {TForm1.BitBtn1Click}

procedure
  TMainForm.MessageWM_SENDSELECTOROFFSET
    (var Message: TMsg);
var
  APointer: Pointer;
begin
  OffsetW := Message.WParam;
  SelectorW := LOWORD (Message.LParam);
  if (SelectorW <> 0) or
     (OffsetW <> 0) then begin
    { Create a pointer out of the selector:offset pair. }
    APointer := MAKELP (OffsetW, SelectorW);
    { Display the newly created pointer. }
    SelectorOffsetLabel.Caption := Format ('%.4x:%.4x', [SelectorW, OffsetW]);
    { Display its contents from Mem32. }
    FromMem32Edit.Text := StrPas (PChar (APointer));
  end;
end; {TForm1.MessageWM_SENDSELECTOROFFSET}

procedure
  TMainForm.SendButtonClick
    (Sender: TObject);
var
  APointer: Pointer;
  Mem32Handle: THandle;
begin
  { Find the window handle of Mem32. }
  Mem32Handle := FindWindow (nil, 'Mem32');
  if (Mem32Handle <> 0) and
     (SelectorW <> 0) and
     (OffsetW <> 0) then begin
    { Create a pointer out of the selector:offset pair. }
    APointer := MAKELP (OffsetW, SelectorW);
    { Copy the return message to the shared memory area. }
    StrPCopy (APointer, ToMem32Edit.Text);
    { Notify Mem32 of the return message. }
    SendMessage (Mem32Handle, WM_RECEIVEMSG, 0, 0);
  end;
end; {TForm1.SendButtonClick}

end.
